import ij.*;
import ij.gui.*;
import ij.measure.*;
import ij.plugin.*;
import ij.plugin.filter.*;
import ij.plugin.frame.*;
import ij.process.*;
import ij.util.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
import java.lang.*;
import java.io.FileWriter;
import java.io.*;
import java.util.StringTokenizer;
import java.text.*;


/****************************************************************
 * This averages 3 slices of a stack to reduce noise.  We must convert to
 * longs to avoid integer overflows.  Just as a precaution.  It also unsigns
 * the pixel value.
 */
 
    
    public class getAverage8Bit implements PlugIn {
      public void run(String arg) {}
      public byte[] getAverage(int slice, ImageStack stack, ImagePlus imp, int numOfSlices){

byte [] [] twoD = new byte[numOfSlices] [imp.getHeight() * imp.getWidth()];
double [] tempArray = new double[imp.getHeight() * imp.getWidth()];
byte[] holder = new byte[imp.getHeight() * imp.getWidth()];  
int holder2 = 0;
byte [] firstArray = new byte[imp.getWidth() * imp.getHeight()];



try {
			 

          if ((numOfSlices %2) == 0) {
          IJ.showMessage("Must be an odd integer.  Resetting your choice k to k-1.");
          numOfSlices = numOfSlices - 1;
          }
          

          if ((numOfSlices%2) !=0) {
            int range = (numOfSlices - 1) / 2;
  
          
            for (int i=0; i < numOfSlices; i++) {

                           holder = (byte [])stack.getPixels((slice - range) + i);
         for (int k=0; k < (imp.getHeight() * imp.getWidth()); k++) {
                  twoD[i] [k] = holder[k];

         }              
              }
              
          }  
            
for (int k=0; k < (imp.getHeight() * imp.getWidth()); k++) {
          for (int i=0; i < numOfSlices; i++) {
            holder2 = holder2 + (int) (twoD[i] [k] & 0xff);
          }
         tempArray[k] = holder2;
holder2 = 0;
}   

for (int k =0; k < (imp.getWidth() * imp.getHeight()); k++) {
          firstArray[k] = (byte) (Math.round((tempArray[k] / (double) numOfSlices)) & 0xff);
}
}


catch (Exception e) {
            IJ.showMessage("Spectrum Extrator Debug",
               "Exception : " + e.toString() +  "  ");
            return null;
        }
return firstArray;
}
}
