import ij.*;
import ij.gui.*;
import ij.measure.*;
import ij.plugin.*;
import ij.plugin.filter.*;
import ij.plugin.frame.*;
import ij.process.*;
import ij.util.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
import java.lang.*;
import java.io.FileWriter;
import java.io.*;
import java.util.StringTokenizer;
import java.text.*;




public class datEnergy implements PlugIn {
   
   public void run (String arg) {
      }
      
	private NumberFormat formatter = NumberFormat.getNumberInstance();

  	public  double[] datEnergy(String dir, String name, int numOfSlices) { 
		double[] energyvalues = new double[numOfSlices];
		formatter.setMaximumFractionDigits(2);
	   formatter.setMinimumFractionDigits(2);
	   
		
		File input = new File("" + dir + name);
	
             if ( !input.exists() || !input.canRead() ) 
             {
	    		 } 
	    
	    else
	    
		try {
	      	  FileReader reader = new FileReader( input );
		  BufferedReader in = new BufferedReader (reader);		  
		  
		  String energies="";
	           String token = "";
	           StringTokenizer tokenizer = new StringTokenizer(energies);
	
			
			for (int i=0; i<numOfSlices; i++)
			{
			
		    	energies = in.readLine();

		    	tokenizer = new StringTokenizer(energies);
		    
		    	token=tokenizer.nextToken();
		    	energyvalues[i] = formatter.parse(token).doubleValue();
		    
			}
				double[] tempEnergies = new double[numOfSlices];
				
			for (int i=0; i<numOfSlices; i++)
			{
				tempEnergies[i] = energyvalues[numOfSlices-1-i];
			}
			
			for (int i=0; i<numOfSlices; i++)
			{
				energyvalues[i]=tempEnergies[i];
			}
				
				
				reader.close(); 
				
        }
			
		  
		    catch ( FileNotFoundException e ) {
		    IJ.showMessage(" Sorry " ); 
		     }
		    catch (IOException e ) { 
		    IJ.showMessage( " Really Sorry " );    
				}
			catch (ParseException e){IJ.showMessage( "I swear I'm Sorry " ); }

		return energyvalues;
		}
}